Index: uspace/lib/c/generic/stats.c
===================================================================
--- uspace/lib/c/generic/stats.c	(revision f4f866c362e11c16ac8b6212e491af00b0bed2f2)
+++ uspace/lib/c/generic/stats.c	(revision f4f866c362e11c16ac8b6212e491af00b0bed2f2)
@@ -0,0 +1,256 @@
+/*
+ * Copyright (c) 2010 Stanislav Kozina
+ * Copyright (c) 2010 Martin Decky
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libc
+ * @{
+ */
+/** @file
+ */
+
+#include <stats.h>
+#include <sysinfo.h>
+#include <assert.h>
+#include <errno.h>
+#include <stdio.h>
+#include <inttypes.h>
+
+#define SYSINFO_STATS_MAX_PATH  64
+
+/** Thread states
+ *
+ */
+static const char *thread_states[] = {
+	"Invalid",
+	"Running",
+	"Sleeping",
+	"Ready",
+	"Entering",
+	"Exiting",
+	"Lingering"
+};
+
+/** Get CPUs statistics
+ *
+ * @param count Number of records returned.
+ *
+ * @return Array of stats_cpu_t structures.
+ *         If non-NULL then it should be eventually freed
+ *         by free().
+ *
+ */
+stats_cpu_t *stats_get_cpus(size_t *count)
+{
+	size_t size = 0;
+	stats_cpu_t *stats_cpus =
+	    (stats_cpu_t *) sysinfo_get_data("system.cpus", &size);
+	
+	assert((size % sizeof(stats_cpu_t)) == 0);
+	
+	*count = size / sizeof(stats_cpu_t);
+	return stats_cpus;
+}
+
+/** Get physical memory statistics
+ *
+ *
+ * @return Pointer to the stats_physmem_t structure.
+ *         If non-NULL then it should be eventually freed
+ *         by free().
+ *
+ */
+stats_physmem_t *stats_get_physmem(void)
+{
+	size_t size = 0;
+	stats_physmem_t *stats_physmem =
+	    (stats_physmem_t *) sysinfo_get_data("system.physmem", &size);
+	
+	assert((size == sizeof(stats_physmem_t)) || (size == 0));
+	
+	return stats_physmem;
+}
+
+/** Get task statistics
+ *
+ * @param count Number of records returned.
+ *
+ * @return Array of stats_task_t structures.
+ *         If non-NULL then it should be eventually freed
+ *         by free().
+ *
+ */
+stats_task_t *stats_get_tasks(size_t *count)
+{
+	size_t size = 0;
+	stats_task_t *stats_tasks =
+	    (stats_task_t *) sysinfo_get_data("system.tasks", &size);
+	
+	assert((size % sizeof(stats_task_t)) == 0);
+	
+	*count = size / sizeof(stats_task_t);
+	return stats_tasks;
+}
+
+/** Get single task statistics
+ *
+ * @param task_id Task ID we are interested in.
+ *
+ * @return Pointer to the stats_task_t structure.
+ *         If non-NULL then it should be eventually freed
+ *         by free().
+ *
+ */
+stats_task_t *stats_get_task(task_id_t task_id)
+{
+	char name[SYSINFO_STATS_MAX_PATH];
+	snprintf(name, SYSINFO_STATS_MAX_PATH, "system.tasks.%" PRIu64, task_id);
+	
+	size_t size = 0;
+	stats_task_t *stats_task =
+	    (stats_task_t *) sysinfo_get_data(name, &size);
+	
+	assert((size == sizeof(stats_task_t)) || (size == 0));
+	
+	return stats_task;
+}
+
+/** Get thread statistics.
+ *
+ * @param count Number of records returned.
+ *
+ * @return Array of stats_thread_t structures.
+ *         If non-NULL then it should be eventually freed
+ *         by free().
+ *
+ */
+stats_thread_t *stats_get_threads(size_t *count)
+{
+	size_t size = 0;
+	stats_thread_t *stats_threads =
+	    (stats_thread_t *) sysinfo_get_data("system.threads", &size);
+	
+	assert((size % sizeof(stats_thread_t)) == 0);
+	
+	*count = size / sizeof(stats_thread_t);
+	return stats_threads;
+}
+
+/** Get single thread statistics
+ *
+ * @param thread_id Thread ID we are interested in.
+ *
+ * @return Pointer to the stats_thread_t structure.
+ *         If non-NULL then it should be eventually freed
+ *         by free().
+ *
+ */
+stats_thread_t *stats_get_thread(thread_id_t thread_id)
+{
+	char name[SYSINFO_STATS_MAX_PATH];
+	snprintf(name, SYSINFO_STATS_MAX_PATH, "system.threads.%" PRIu64, thread_id);
+	
+	size_t size = 0;
+	stats_thread_t *stats_thread =
+	    (stats_thread_t *) sysinfo_get_data(name, &size);
+	
+	assert((size == sizeof(stats_thread_t)) || (size == 0));
+	
+	return stats_thread;
+}
+
+/** Get system load
+ *
+ * @param count Number of load records returned.
+ *
+ * @return Array of load records (load_t).
+ *         If non-NULL then it should be eventually freed
+ *         by free().
+ *
+ */
+load_t *stats_get_load(size_t *count)
+{
+	size_t size = 0;
+	load_t *load =
+	    (load_t *) sysinfo_get_data("system.load", &size);
+	
+	assert((size % sizeof(load_t)) == 0);
+	
+	*count = size / sizeof(load_t);
+	return load;
+}
+
+/** Get system uptime
+ *
+ * @return System uptime (in seconds).
+ *
+ */
+sysarg_t stats_get_uptime(void)
+{
+	sysarg_t uptime;
+	if (sysinfo_get_value("system.uptime", &uptime) != EOK)
+		uptime = 0;
+	
+	return uptime;
+}
+
+/** Print load fixed-point value
+ *
+ * Print the load record fixed-point value in decimal
+ * representation on stdout.
+ *
+ * @param upper      Load record.
+ * @param dec_length Number of decimal digits to print.
+ *
+ */
+void stats_print_load_fragment(load_t upper, unsigned int dec_length)
+{
+	/* Magic value from BSD */
+	load_t lower = 65536;
+	
+	/* Print the whole part */
+	printf("%u.", upper / lower);
+	
+	load_t rest = (upper % lower) * 10;
+	
+	unsigned int i;
+	for (i = 0; i < dec_length; i++) {
+		printf("%u", rest / lower);
+		rest = (rest % lower) * 10;
+	}
+}
+
+const char *thread_get_state(state_t state)
+{
+	if (state <= Lingering)
+		return thread_states[state];
+	
+	return thread_states[Invalid];
+}
+
+/** @}
+ */
Index: uspace/lib/c/generic/str.c
===================================================================
--- uspace/lib/c/generic/str.c	(revision 38aaacc20a85af2361a0240ac2e7d643e086ecfa)
+++ uspace/lib/c/generic/str.c	(revision f4f866c362e11c16ac8b6212e491af00b0bed2f2)
@@ -471,5 +471,5 @@
  * null-terminated and containing only complete characters.
  *
- * @param dest   Destination buffer.
+ * @param dest  Destination buffer.
  * @param count Size of the destination buffer (must be > 0).
  * @param src   Source string.
@@ -477,19 +477,16 @@
 void str_cpy(char *dest, size_t size, const char *src)
 {
-	wchar_t ch;
-	size_t src_off;
-	size_t dest_off;
-
 	/* There must be space for a null terminator in the buffer. */
 	assert(size > 0);
 	
-	src_off = 0;
-	dest_off = 0;
-
+	size_t src_off = 0;
+	size_t dest_off = 0;
+	
+	wchar_t ch;
 	while ((ch = str_decode(src, &src_off, STR_NO_LIMIT)) != 0) {
 		if (chr_encode(ch, dest, &dest_off, size - 1) != EOK)
 			break;
 	}
-
+	
 	dest[dest_off] = '\0';
 }
@@ -505,26 +502,23 @@
  * have to be null-terminated.
  *
- * @param dest   Destination buffer.
+ * @param dest  Destination buffer.
  * @param count Size of the destination buffer (must be > 0).
  * @param src   Source string.
- * @param n	Maximum number of bytes to read from @a src.
+ * @param n     Maximum number of bytes to read from @a src.
  */
 void str_ncpy(char *dest, size_t size, const char *src, size_t n)
 {
-	wchar_t ch;
-	size_t src_off;
-	size_t dest_off;
-
 	/* There must be space for a null terminator in the buffer. */
 	assert(size > 0);
 	
-	src_off = 0;
-	dest_off = 0;
-
+	size_t src_off = 0;
+	size_t dest_off = 0;
+	
+	wchar_t ch;
 	while ((ch = str_decode(src, &src_off, n)) != 0) {
 		if (chr_encode(ch, dest, &dest_off, size - 1) != EOK)
 			break;
 	}
-
+	
 	dest[dest_off] = '\0';
 }
@@ -896,28 +890,62 @@
 }
 
+/** Duplicate string.
+ *
+ * Allocate a new string and copy characters from the source
+ * string into it. The duplicate string is allocated via sleeping
+ * malloc(), thus this function can sleep in no memory conditions.
+ *
+ * The allocation cannot fail and the return value is always
+ * a valid pointer. The duplicate string is always a well-formed
+ * null-terminated UTF-8 string, but it can differ from the source
+ * string on the byte level.
+ *
+ * @param src Source string.
+ *
+ * @return Duplicate string.
+ *
+ */
 char *str_dup(const char *src)
 {
-	size_t size = str_size(src);
-	void *dest = malloc(size + 1);
-	
+	size_t size = str_size(src) + 1;
+	char *dest = (char *) malloc(size);
 	if (dest == NULL)
 		return (char *) NULL;
 	
-	return (char *) memcpy(dest, src, size + 1);
-}
-
-char *str_ndup(const char *src, size_t max_size)
+	str_cpy(dest, size, src);
+	return dest;
+}
+
+/** Duplicate string with size limit.
+ *
+ * Allocate a new string and copy up to @max_size bytes from the source
+ * string into it. The duplicate string is allocated via sleeping
+ * malloc(), thus this function can sleep in no memory conditions.
+ * No more than @max_size + 1 bytes is allocated, but if the size
+ * occupied by the source string is smaller than @max_size + 1,
+ * less is allocated.
+ *
+ * The allocation cannot fail and the return value is always
+ * a valid pointer. The duplicate string is always a well-formed
+ * null-terminated UTF-8 string, but it can differ from the source
+ * string on the byte level.
+ *
+ * @param src Source string.
+ * @param n   Maximum number of bytes to duplicate.
+ *
+ * @return Duplicate string.
+ *
+ */
+char *str_ndup(const char *src, size_t n)
 {
 	size_t size = str_size(src);
-	if (size > max_size)
-		size = max_size;
+	if (size > n)
+		size = n;
 	
 	char *dest = (char *) malloc(size + 1);
-	
 	if (dest == NULL)
 		return (char *) NULL;
 	
-	memcpy(dest, src, size);
-	dest[size] = 0;
+	str_ncpy(dest, size + 1, src, size);
 	return dest;
 }
@@ -979,4 +1007,30 @@
 }
 
+void order_suffix(const uint64_t val, uint64_t *rv, char *suffix)
+{
+	if (val > 10000000000000000000ULL) {
+		*rv = val / 1000000000000000000ULL;
+		*suffix = 'Z';
+	} else if (val > 1000000000000000000ULL) {
+		*rv = val / 1000000000000000ULL;
+		*suffix = 'E';
+	} else if (val > 1000000000000000ULL) {
+		*rv = val / 1000000000000ULL;
+		*suffix = 'T';
+	} else if (val > 1000000000000ULL) {
+		*rv = val / 1000000000ULL;
+		*suffix = 'G';
+	} else if (val > 1000000000ULL) {
+		*rv = val / 1000000ULL;
+		*suffix = 'M';
+	} else if (val > 1000000ULL) {
+		*rv = val / 1000ULL;
+		*suffix = 'k';
+	} else {
+		*rv = val;
+		*suffix = ' ';
+	}
+}
+
 /** @}
  */
Index: uspace/lib/c/generic/str_error.c
===================================================================
--- uspace/lib/c/generic/str_error.c	(revision f4f866c362e11c16ac8b6212e491af00b0bed2f2)
+++ uspace/lib/c/generic/str_error.c	(revision f4f866c362e11c16ac8b6212e491af00b0bed2f2)
@@ -0,0 +1,75 @@
+/*
+ * Copyright (c) 2010 Martin Decky
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libc
+ * @{
+ */
+/** @file
+ */
+
+#include <str_error.h>
+#include <stdio.h>
+#include <fibril.h>
+
+#define MIN_ERRNO  -17
+#define NOERR_LEN  64
+
+static const char* err_desc[] = {
+	"No error",
+	"No such entry",
+	"Not enough memory",
+	"Limit exceeded", 
+	"Connection refused",
+	"Forwarding error",
+	"Permission denied",
+	"Answerbox closed connection",
+	"Other party error",
+	"Entry already exists",
+	"Bad memory pointer",
+	"Not supported",
+	"Address not available",
+	"Timeout expired",
+	"Invalid value",
+	"Resource is busy",
+	"Result does not fit its size",
+	"Operation interrupted"
+};
+
+static fibril_local char noerr[NOERR_LEN];
+
+const char *str_error(const int errno)
+{
+	if ((errno <= 0) && (errno >= MIN_ERRNO))
+		return err_desc[-errno];
+	
+	snprintf(noerr, NOERR_LEN, "Unkown error code %d", errno);
+	return noerr;
+}
+
+/** @}
+ */
Index: uspace/lib/c/generic/sysinfo.c
===================================================================
--- uspace/lib/c/generic/sysinfo.c	(revision 38aaacc20a85af2361a0240ac2e7d643e086ecfa)
+++ uspace/lib/c/generic/sysinfo.c	(revision f4f866c362e11c16ac8b6212e491af00b0bed2f2)
@@ -31,14 +31,109 @@
  */
 /** @file
- */ 
+ */
 
 #include <libc.h>
 #include <sysinfo.h>
 #include <str.h>
+#include <errno.h>
+#include <malloc.h>
+#include <bool.h>
 
-sysarg_t sysinfo_value(const char *name)
+/** Get sysinfo item type
+ *
+ * @param path Sysinfo path.
+ *
+ * @return Sysinfo item type.
+ *
+ */
+sysinfo_item_tag_t sysinfo_get_tag(const char *path)
 {
-	return __SYSCALL2(SYS_SYSINFO_VALUE, (sysarg_t) name,
-	    (sysarg_t) str_size(name));
+	return (sysinfo_item_tag_t) __SYSCALL2(SYS_SYSINFO_GET_TAG,
+	    (sysarg_t) path, (sysarg_t) str_size(path));
+}
+
+/** Get sysinfo numerical value
+ *
+ * @param path  Sysinfo path.
+ * @param value Pointer to store the numerical value to.
+ *
+ * @return EOK if the value was successfully read and
+ *         is of SYSINFO_VAL_VAL type.
+ *
+ */
+int sysinfo_get_value(const char *path, sysarg_t *value)
+{
+	return (int) __SYSCALL3(SYS_SYSINFO_GET_VALUE, (sysarg_t) path,
+	    (sysarg_t) str_size(path), (sysarg_t) value);
+}
+
+/** Get sysinfo binary data size
+ *
+ * @param path  Sysinfo path.
+ * @param value Pointer to store the binary data size.
+ *
+ * @return EOK if the value was successfully read and
+ *         is of SYSINFO_VAL_DATA type.
+ *
+ */
+static int sysinfo_get_data_size(const char *path, size_t *size)
+{
+	return (int) __SYSCALL3(SYS_SYSINFO_GET_DATA_SIZE, (sysarg_t) path,
+	    (sysarg_t) str_size(path), (sysarg_t) size);
+}
+
+/** Get sysinfo binary data
+ *
+ * @param path  Sysinfo path.
+ * @param value Pointer to store the binary data size.
+ *
+ * @return Binary data read from sysinfo or NULL if the
+ *         sysinfo item value type is not binary data.
+ *         The returned non-NULL pointer should be
+ *         freed by free().
+ *
+ */
+void *sysinfo_get_data(const char *path, size_t *size)
+{
+	/* The binary data size might change during time.
+	   Unfortunatelly we cannot allocate the buffer
+	   and transfer the data as a single atomic operation.
+	
+	   Let's hope that the number of iterations is bounded
+	   in common cases. */
+	
+	void *data = NULL;
+	
+	while (true) {
+		/* Get the binary data size */
+		int ret = sysinfo_get_data_size(path, size);
+		if ((ret != EOK) || (size == 0)) {
+			/* Not a binary data item
+			   or an empty item */
+			break;
+		}
+		
+		data = realloc(data, *size);
+		if (data == NULL)
+			break;
+		
+		/* Get the data */
+		ret = __SYSCALL4(SYS_SYSINFO_GET_DATA, (sysarg_t) path,
+		    (sysarg_t) str_size(path), (sysarg_t) data, (sysarg_t) *size);
+		if (ret == EOK)
+			return data;
+		
+		if (ret != ENOMEM) {
+			/* The failure to get the data was not caused
+			   by wrong buffer size */
+			break;
+		}
+	}
+	
+	if (data != NULL)
+		free(data);
+	
+	*size = 0;
+	return NULL;
 }
 
Index: uspace/lib/c/generic/task.c
===================================================================
--- uspace/lib/c/generic/task.c	(revision 38aaacc20a85af2361a0240ac2e7d643e086ecfa)
+++ uspace/lib/c/generic/task.c	(revision f4f866c362e11c16ac8b6212e491af00b0bed2f2)
@@ -70,16 +70,21 @@
  * loader API.
  *
- * @param path pathname of the binary to execute
- * @param argv command-line arguments
+ * @param path Pathname of the binary to execute.
+ * @param argv Command-line arguments.
+ * @param err  If not NULL, the error value is stored here.
  *
  * @return ID of the newly created task or zero on error.
  *
  */
-task_id_t task_spawn(const char *path, const char *const args[])
+task_id_t task_spawn(const char *path, const char *const args[], int *err)
 {
 	/* Connect to a program loader. */
 	loader_t *ldr = loader_connect();
-	if (ldr == NULL)
+	if (ldr == NULL) {
+		if (err != NULL)
+			*err = EREFUSED;
+		
 		return 0;
+	}
 	
 	/* Get task ID. */
@@ -143,4 +148,8 @@
 	/* Success */
 	free(ldr);
+	
+	if (err != NULL)
+		*err = EOK;
+	
 	return task_id;
 	
@@ -149,4 +158,7 @@
 	loader_abort(ldr);
 	free(ldr);
+	
+	if (err != NULL)
+		*err = rc;
 	
 	return 0;
Index: uspace/lib/c/include/arg_parse.h
===================================================================
--- uspace/lib/c/include/arg_parse.h	(revision f4f866c362e11c16ac8b6212e491af00b0bed2f2)
+++ uspace/lib/c/include/arg_parse.h	(revision f4f866c362e11c16ac8b6212e491af00b0bed2f2)
@@ -0,0 +1,48 @@
+/*
+ * Copyright (c) 2009 Lukas Mejdrech
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libc
+ * @{
+ */
+/** @file
+ */
+
+#ifndef LIBC_ARG_PARSE_H_
+#define LIBC_ARG_PARSE_H_
+
+typedef int (*arg_parser)(const char *, int *);
+
+extern int arg_parse_short_long(const char *, const char *, const char *);
+extern int arg_parse_int(int, char **, int *, int *, int);
+extern int arg_parse_name_int(int, char **, int *, int *, int, arg_parser);
+extern int arg_parse_string(int, char **, int *, char **, int);
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/c/include/bool.h
===================================================================
--- uspace/lib/c/include/bool.h	(revision 38aaacc20a85af2361a0240ac2e7d643e086ecfa)
+++ uspace/lib/c/include/bool.h	(revision f4f866c362e11c16ac8b6212e491af00b0bed2f2)
@@ -36,8 +36,10 @@
 #define LIBC_BOOL_H_
 
-#define false 0
-#define true 1
+#include <libarch/types.h>
 
-typedef short bool;
+#define false  0
+#define true   1
+
+typedef uint8_t bool;
 
 #endif
Index: uspace/lib/c/include/errno.h
===================================================================
--- uspace/lib/c/include/errno.h	(revision 38aaacc20a85af2361a0240ac2e7d643e086ecfa)
+++ uspace/lib/c/include/errno.h	(revision f4f866c362e11c16ac8b6212e491af00b0bed2f2)
@@ -43,5 +43,5 @@
 #define errno _errno
 
-#define EMFILE        (-17)
+#define EMFILE        (-18)
 #define ENAMETOOLONG  (-256)
 #define EISDIR        (-257)
Index: uspace/lib/c/include/io/color.h
===================================================================
--- uspace/lib/c/include/io/color.h	(revision 38aaacc20a85af2361a0240ac2e7d643e086ecfa)
+++ uspace/lib/c/include/io/color.h	(revision f4f866c362e11c16ac8b6212e491af00b0bed2f2)
@@ -36,5 +36,5 @@
 #define LIBC_IO_COLOR_H_
 
-enum console_color {
+typedef enum {
 	COLOR_BLACK   = 0,
 	COLOR_BLUE    = 1,
@@ -48,5 +48,5 @@
 	CATTR_BRIGHT  = 8,
 	CATTR_BLINK   = 8
-};
+} console_color_t;
 
 #endif
Index: uspace/lib/c/include/io/console.h
===================================================================
--- uspace/lib/c/include/io/console.h	(revision 38aaacc20a85af2361a0240ac2e7d643e086ecfa)
+++ uspace/lib/c/include/io/console.h	(revision f4f866c362e11c16ac8b6212e491af00b0bed2f2)
@@ -44,10 +44,10 @@
 } console_ev_type_t;
 
-enum {
+typedef enum {
 	CONSOLE_CCAP_NONE = 0,
 	CONSOLE_CCAP_STYLE,
 	CONSOLE_CCAP_INDEXED,
 	CONSOLE_CCAP_RGB
-};
+} console_caps_t;
 
 /** Console event structure. */
@@ -68,14 +68,15 @@
 extern void console_clear(int phone);
 
-extern int console_get_size(int phone, int *cols, int *rows);
-extern int console_get_pos(int phone, int *col, int *row);
-extern void console_goto(int phone, int col, int row);
+extern int console_get_size(int phone, ipcarg_t *cols, ipcarg_t *rows);
+extern int console_get_pos(int phone, ipcarg_t *col, ipcarg_t *row);
+extern void console_set_pos(int phone, ipcarg_t col, ipcarg_t row);
 
-extern void console_set_style(int phone, int style);
-extern void console_set_color(int phone, int fg_color, int bg_color, int flags);
-extern void console_set_rgb_color(int phone, int fg_color, int bg_color);
+extern void console_set_style(int phone, uint8_t style);
+extern void console_set_color(int phone, uint8_t fg_color, uint8_t bg_color,
+    uint8_t flags);
+extern void console_set_rgb_color(int phone, uint32_t fg_color, uint32_t bg_color);
 
 extern void console_cursor_visibility(int phone, bool show);
-extern int console_get_color_cap(int phone, int *ccap);
+extern int console_get_color_cap(int phone, ipcarg_t *ccap);
 extern void console_kcon_enable(int phone);
 
Index: uspace/lib/c/include/io/keycode.h
===================================================================
--- uspace/lib/c/include/io/keycode.h	(revision 38aaacc20a85af2361a0240ac2e7d643e086ecfa)
+++ uspace/lib/c/include/io/keycode.h	(revision f4f866c362e11c16ac8b6212e491af00b0bed2f2)
@@ -51,5 +51,5 @@
  * they really are organized here by position, rather than by label.
  */
-enum keycode {
+typedef enum {
 
 	/* Main block row 1 */
@@ -199,5 +199,5 @@
 } keycode_t;
 
-enum keymod {
+typedef enum {
 	KM_LSHIFT      = 0x001,
 	KM_RSHIFT      = 0x002,
Index: uspace/lib/c/include/io/klog.h
===================================================================
--- uspace/lib/c/include/io/klog.h	(revision 38aaacc20a85af2361a0240ac2e7d643e086ecfa)
+++ uspace/lib/c/include/io/klog.h	(revision f4f866c362e11c16ac8b6212e491af00b0bed2f2)
@@ -33,10 +33,10 @@
  */
 
-#ifndef LIBC_STREAM_H_
-#define LIBC_STREAM_H_
+#ifndef LIBC_IO_KLOG_H_
+#define LIBC_IO_KLOG_H_
 
 #include <sys/types.h>
 
-extern size_t klog_write(const void *buf, size_t size);
+extern size_t klog_write(const void *, size_t);
 extern void klog_update(void);
 
Index: uspace/lib/c/include/io/printf_core.h
===================================================================
--- uspace/lib/c/include/io/printf_core.h	(revision 38aaacc20a85af2361a0240ac2e7d643e086ecfa)
+++ uspace/lib/c/include/io/printf_core.h	(revision f4f866c362e11c16ac8b6212e491af00b0bed2f2)
@@ -40,5 +40,5 @@
 
 /** Structure for specifying output methods for different printf clones. */
-typedef struct printf_spec {
+typedef struct {
 	/* String output function, returns number of printed characters or EOF */
 	int (*str_write)(const char *, size_t, void *);
@@ -51,5 +51,5 @@
 } printf_spec_t;
 
-int printf_core(const char *fmt, printf_spec_t *ps, va_list ap);
+extern int printf_core(const char *, printf_spec_t *, va_list);
 
 #endif
Index: uspace/lib/c/include/io/screenbuffer.h
===================================================================
--- uspace/lib/c/include/io/screenbuffer.h	(revision f4f866c362e11c16ac8b6212e491af00b0bed2f2)
+++ uspace/lib/c/include/io/screenbuffer.h	(revision f4f866c362e11c16ac8b6212e491af00b0bed2f2)
@@ -0,0 +1,158 @@
+/*
+ * Copyright (c) 2006 Josef Cejka
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup console
+ * @{
+ */
+/** @file
+ */
+
+#ifndef LIBC_SCREENBUFFER_H__
+#define LIBC_SCREENBUFFER_H__
+
+#include <stdint.h>
+#include <sys/types.h>
+#include <ipc/ipc.h>
+#include <bool.h>
+
+typedef enum {
+	at_style,
+	at_idx,
+	at_rgb
+} attr_type_t;
+
+typedef struct {
+	uint8_t style;
+} attr_style_t;
+
+typedef struct {
+	uint8_t fg_color;
+	uint8_t bg_color;
+	uint8_t flags;
+} attr_idx_t;
+
+typedef struct {
+	uint32_t bg_color;  /**< background color */
+	uint32_t fg_color;  /**< foreground color */
+} attr_rgb_t;
+
+typedef union {
+	attr_style_t s;
+	attr_idx_t i;
+	attr_rgb_t r;
+} attr_val_t;
+
+typedef struct {
+	attr_type_t t;
+	attr_val_t a;
+} attrs_t;
+
+/** One field on screen. It contain one character and its attributes. */
+typedef struct {
+	wchar_t character;  /**< Character itself */
+	attrs_t attrs;      /**< Character attributes */
+} keyfield_t;
+
+/** Structure for buffering state of one virtual console.
+ */
+typedef struct {
+	keyfield_t *buffer;      /**< Screen content - characters and
+	                              their attributes (used as a circular buffer) */
+	ipcarg_t size_x;         /**< Number of columns  */
+	ipcarg_t size_y;         /**< Number of rows */
+	
+	/** Coordinates of last printed character for determining cursor position */
+	ipcarg_t position_x;
+	ipcarg_t position_y;
+	
+	attrs_t attrs;           /**< Current attributes. */
+	size_t top_line;         /**< Points to buffer[][] line that will
+	                              be printed at screen as the first line */
+	bool is_cursor_visible;  /**< Cursor state - default is visible */
+} screenbuffer_t;
+
+/** Returns keyfield for position on screen
+ *
+ * Screenbuffer->buffer is cyclic buffer so we
+ * must couted in index of the topmost line.
+ *
+ * @param scr Screenbuffer
+ * @param x   Position on screen
+ * @param y   Position on screen
+ *
+ * @return Keyfield structure with character and its attributes on x, y
+ *
+ */
+static inline keyfield_t *get_field_at(screenbuffer_t *scr, ipcarg_t x, ipcarg_t y)
+{
+	return scr->buffer + x + ((y + scr->top_line) % scr->size_y) * scr->size_x;
+}
+
+/** Compares two sets of attributes.
+ *
+ * @param s1 First style
+ * @param s2 Second style
+ *
+ * @return Nonzero on equality
+ *
+ */
+static inline bool attrs_same(attrs_t a1, attrs_t a2)
+{
+	if (a1.t != a2.t)
+		return false;
+	
+	switch (a1.t) {
+	case at_style:
+		return (a1.a.s.style == a2.a.s.style);
+	case at_idx:
+		return (a1.a.i.fg_color == a2.a.i.fg_color)
+		    && (a1.a.i.bg_color == a2.a.i.bg_color)
+		    && (a1.a.i.flags == a2.a.i.flags);
+	case at_rgb:
+		return (a1.a.r.fg_color == a2.a.r.fg_color)
+		    && (a1.a.r.bg_color == a2.a.r.bg_color);
+	}
+	
+	return false;
+}
+
+extern void screenbuffer_putchar(screenbuffer_t *, wchar_t);
+extern screenbuffer_t *screenbuffer_init(screenbuffer_t *, ipcarg_t, ipcarg_t);
+
+extern void screenbuffer_clear(screenbuffer_t *);
+extern void screenbuffer_clear_line(screenbuffer_t *, ipcarg_t);
+extern void screenbuffer_copy_buffer(screenbuffer_t *, keyfield_t *);
+extern void screenbuffer_goto(screenbuffer_t *, ipcarg_t, ipcarg_t);
+extern void screenbuffer_set_style(screenbuffer_t *, uint8_t);
+extern void screenbuffer_set_color(screenbuffer_t *, uint8_t, uint8_t, uint8_t);
+extern void screenbuffer_set_rgb_color(screenbuffer_t *, uint32_t, uint32_t);
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/c/include/io/style.h
===================================================================
--- uspace/lib/c/include/io/style.h	(revision 38aaacc20a85af2361a0240ac2e7d643e086ecfa)
+++ uspace/lib/c/include/io/style.h	(revision f4f866c362e11c16ac8b6212e491af00b0bed2f2)
@@ -36,8 +36,10 @@
 #define LIBC_IO_STYLE_H_
 
-enum console_style {
+typedef enum {
 	STYLE_NORMAL   = 0,
-	STYLE_EMPHASIS = 1
-};
+	STYLE_EMPHASIS = 1,
+	STYLE_INVERTED = 2,
+	STYLE_SELECTED = 3
+} console_style_t;
 
 #endif
